var debounce  = require('lodash.debounce')
var R  = require('ramda')

//$setAspectRatios :: jQuery -> 'selector' -> I/O
var $setAspectRatios = function($, selector) {
	var container = $(selector)
	
	if (container.length === 0) {return}
	
	var setAspectRatio = function($element) {
		var height;
		var str_ratio = $element.data('ratio')
		var error = '[setAspectRatios] el ratio fue mal ingresado ('+str_ratio+'), o falta, en este nodo'
		var horizontal, vertical, h_v
		
		if (!str_ratio || typeof str_ratio === 'number') {return console.error(error, $element);}
		
		h_v = str_ratio.split(':').map(Number)
		horizontal = h_v[0];
		vertical = h_v[1];

		if (!(vertical && horizontal)) {return console.error(error, $element);}
		
		height = $element.width() / horizontal * vertical;
		$element.height(height)
		$element.width('100%')

		$(window).on('resize', debounce(function() {
			height = $element.width() / horizontal * vertical;
			$element.height(height)
			$element.width('100%')			
		}, 100))
	}

	container.each(function(i, el) {setAspectRatio($(el))})
}

module.exports = $setAspectRatios